CMD_TOUCH="/usr/bin/touch"

_rsync()
{
    local src=$1
    local dst=$2

    elog "RSYNC from [${src}] to [${dst}]"
    ${CMD_RSYNC} -a --delete ${src} ${dst}
}

_copy()
{
    local src=$1
    local dst=$2

    elog "COPY from [${src}] to [${dst}]"
    ${CMD_CP} -an ${src} ${dst}
}

set_app_link()
{
    local exe_path=$1
    local exe_link=$(${CMD_READLINK} ${exe_path})
    local priv_path=$2
    local priv_dir=$(${CMD_DIRNAME} ${priv_path})
    local def_path=$3
    local overwrite=${4:-${TRUE}}

    if [ -e ${def_path} ]; then
        if [ x"${overwrite}" == x"${TRUE}" ]; then
            _rsync ${def_path} ${priv_dir}
        elif [ x"${overwrite}" == x"${TRUE}" ] && [ -f ${exe_path} ]; then
            _copy ${exe_path} ${priv_dir}
        fi
    fi

    if [ x"${exe_link}" == x"${priv_path}" ]; then
        elog "LINK: [${priv_path}] -> [${exe_path}] has already been created"
        return
    fi
    create_link ${priv_path} ${exe_path}
}

